diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/spark.cpp alien-rc4/src//game/server/entities/spark.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/spark.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/spark.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,94 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#include <game/generated/protocol.h>
+#include <game/server/gamecontext.h>
+#include "spark.h"
+#include <game/server/gamemodes/mod.h>
+
+CSpark::CSpark(CGameWorld *pGameWorld, vec2 Pos)
+: CEntity(pGameWorld, CGameWorld::ENTTYPE_LASER)
+{
+	m_Pos = Pos;
+	m_EvalTick = 0;
+	m_DieTick = 0;
+	m_NextDetonationTick = 0;
+	m_InitDie = 0;
+	GameWorld()->InsertEntity(this);
+}
+
+bool CSpark::HitCharacter()
+{
+	vec2 At;
+		
+	// Check Collision
+	CCharacter *Hit = GameServer()->m_World.ClosestCharacter(m_Pos, 5.0f, 0);
+	if(!Hit)
+		return false;
+
+	if(GameServer()->m_pController->MutPowerSupply())
+		Hit->BreakCircuit();
+
+	Hit->TakeDamage(vec2(0.f, 0.f), GameServer()->Tuning()->m_LaserDamage, -1, WEAPON_RIFLE);
+	return true;
+}
+
+void CSpark::Reset()
+{
+	m_InitDie = 0;
+}
+
+void CSpark::Tick()
+{
+	if(Server()->Tick() % (100 * Server()->TickSpeed() / 1000) == 0)
+		m_EvalTick = Server()->Tick();
+	else
+	{
+
+		if(GameServer()->m_pController->MutPowerSupply() == 0)
+		{
+			if(!m_InitDie)
+			{
+				m_InitDie = 1;
+				m_DieTick = Server()->Tick() + 5 * Server()->TickSpeed();
+				m_NextDetonationTick = Server()->Tick();
+				GameServer()->CreateExplosion(m_Pos, -1, WEAPON_GRENADE, true);
+				GameServer()->CreateExplosion(m_Pos, -1, WEAPON_GRENADE, true);
+			}
+			else if(m_InitDie < 2)
+			{
+				if(Server()->Tick() - m_DieTick > 0)
+				{
+					GameServer()->CreateExplosion(m_Pos, -1, WEAPON_GRENADE, true);
+					GameServer()->CreateSound(m_Pos, SOUND_GRENADE_EXPLODE);
+					m_InitDie = 2;
+				}
+				else if(Server()->Tick() - m_NextDetonationTick > 0)
+				{
+					GameServer()->CreateExplosion(m_Pos, -1, WEAPON_GRENADE, true);
+					GameServer()->CreateSound(m_Pos, SOUND_GRENADE_EXPLODE);
+					m_NextDetonationTick = Server()->Tick() + (50 + rand()%500) * Server()->TickSpeed() / 1000;
+				}
+			}
+		}
+		else
+			HitCharacter();
+	}
+}
+
+void CSpark::Snap(int SnappingClient)
+{
+	if(GameServer()->m_pController->MutPowerSupply() == 0)
+		return;
+
+	if(NetworkClipped(SnappingClient))
+		return;
+
+	CNetObj_Laser *pObj = static_cast<CNetObj_Laser *>(Server()->SnapNewItem(NETOBJTYPE_LASER, m_ID, sizeof(CNetObj_Laser)));
+	if(!pObj)
+		return;
+
+	pObj->m_X = (int)m_Pos.x;
+	pObj->m_Y = (int)m_Pos.y;
+	pObj->m_FromX = (int)m_Pos.x;
+	pObj->m_FromY = (int)m_Pos.y;
+	pObj->m_StartTick = m_EvalTick;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/spark.h alien-rc4/src//game/server/entities/spark.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/spark.h	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/spark.h	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,26 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#ifndef GAME_SERVER_ENTITIES_SPARK_H
+#define GAME_SERVER_ENTITIES_SPARK_H
+
+#include <game/server/entity.h>
+
+class CSpark : public CEntity
+{
+public:
+	CSpark(CGameWorld *pGameWorld, vec2 Pos);
+
+	virtual void Reset();
+	virtual void Tick();
+	virtual void Snap(int SnappingClient);
+
+protected:
+	bool HitCharacter();
+
+private:
+	int m_EvalTick;
+	int m_DieTick;
+	int m_NextDetonationTick;
+	int m_InitDie;
+};
+
+#endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entity.h alien-rc4/src//game/server/entity.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entity.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entity.h	2012-06-14 23:57:39.000000000 +0200
@@ -106,6 +106,12 @@ public:
 	virtual void TickDefered() {}
 
 	/*
+		Function: TickPaused
+			Called when the game is paused, to freeze the state and position of the entity.
+	*/
+	virtual void TickPaused() {}
+
+	/*
 		Function: snap
 			Called when a new snapshot is being generated for a specific
 			client.
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/gamecontext.cpp alien-rc4/src//game/server/gamecontext.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/gamecontext.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/gamecontext.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -33,6 +33,7 @@ void CGameContext::Construct(int Resetti
 	m_pVoteOptionFirst = 0;
 	m_pVoteOptionLast = 0;
 	m_NumVoteOptions = 0;
+	m_LockTeams = 0;
 
 	if(Resetting==NO_RESET)
 		m_pVoteOptionHeap = new CHeap();
@@ -141,8 +142,20 @@ void CGameContext::CreateExplosion(vec2
 				ForceDir = normalize(Diff);
 			l = 1-clamp((l-InnerRadius)/(Radius-InnerRadius), 0.0f, 1.0f);
 			float Dmg = 6 * l;
+
+			// Mutator
 			if((int)Dmg)
-				apEnts[i]->TakeDamage(ForceDir*Dmg*2, (int)Dmg, Owner, Weapon);
+			{
+				if(Weapon == WEAPON_SHOTGUN)
+				{
+					if(Dmg > 2.f)
+						Dmg = 2.0;
+		
+					apEnts[i]->TakeDamage(ForceDir*Dmg*2, int(Dmg), Owner, Weapon);
+				}
+				else
+					apEnts[i]->TakeDamage(ForceDir*Dmg*2, (int)Dmg, Owner, Weapon);
+			}
 		}
 	}
 }
@@ -204,7 +217,15 @@ void CGameContext::CreateSoundGlobal(int
 
 	CNetMsg_Sv_SoundGlobal Msg;
 	Msg.m_SoundID = Sound;
-	Server()->SendPackMsg(&Msg, MSGFLAG_VITAL, Target);
+	if(Target == -2)
+		Server()->SendPackMsg(&Msg, MSGFLAG_NOSEND, -1);
+	else
+	{
+		int Flag = MSGFLAG_VITAL;
+		if(Target != -1)
+			Flag |= MSGFLAG_NORECORD;
+		Server()->SendPackMsg(&Msg, Flag, Target);
+	}
 }
 
 
@@ -248,7 +269,12 @@ void CGameContext::SendChat(int ChatterC
 		// send to the clients
 		for(int i = 0; i < MAX_CLIENTS; i++)
 		{
-			if(m_apPlayers[i] && m_apPlayers[i]->GetTeam() == Team)
+			if(Team == TEAM_SPECTATORS)
+			{
+				if(m_apPlayers[i] && m_apPlayers[i]->GetTeam() == TEAM_SPECTATORS)
+					Server()->SendPackMsg(&Msg, MSGFLAG_VITAL|MSGFLAG_NORECORD, i);
+			}
+			else if(m_apPlayers[i] && ((m_apPlayers[i]->m_MutatorTeam <= TEAM_MUTANT && Team <= TEAM_MUTANT) || (m_apPlayers[i]->m_MutatorTeam >= TEAM_HUMAN && Team >= TEAM_HUMAN)))
 				Server()->SendPackMsg(&Msg, MSGFLAG_VITAL|MSGFLAG_NORECORD, i);
 		}
 	}
@@ -379,6 +405,22 @@ void CGameContext::SendTuningParams(int
 	Server()->SendMsg(&Msg, MSGFLAG_VITAL, ClientID);
 }
 
+void CGameContext::SwapTeams()
+{
+	if(!m_pController->IsTeamplay())
+		return;
+	
+	SendChat(-1, CGameContext::CHAT_ALL, "Teams were swapped");
+
+	for(int i = 0; i < MAX_CLIENTS; ++i)
+	{
+		if(m_apPlayers[i] && m_apPlayers[i]->GetTeam() != TEAM_SPECTATORS)
+			m_apPlayers[i]->SetTeam(m_apPlayers[i]->GetTeam()^1, false);
+	}
+
+	(void)m_pController->CheckTeamBalance();
+}
+
 void CGameContext::OnTick()
 {
 	// check tuning
@@ -457,7 +499,9 @@ void CGameContext::OnTick()
 
 			if(m_VoteEnforce == VOTE_ENFORCE_YES)
 			{
+				Server()->SetRconCID(IServer::RCON_CID_VOTE);
 				Console()->ExecuteLine(m_aVoteCommand);
+				Server()->SetRconCID(IServer::RCON_CID_SERV);
 				EndVote();
 				SendChat(-1, CGameContext::CHAT_ALL, "Vote passed");
 
@@ -583,7 +627,12 @@ void CGameContext::OnMessage(int MsgID,
 		CNetMsg_Cl_Say *pMsg = (CNetMsg_Cl_Say *)pRawMsg;
 		int Team = pMsg->m_Team;
 		if(Team)
-			Team = pPlayer->GetTeam();
+		{
+			if(pPlayer->GetTeam() > -1)
+				Team = pPlayer->m_MutatorTeam;
+			else
+				Team = TEAM_SPECTATORS;
+		}
 		else
 			Team = CGameContext::CHAT_ALL;
 
@@ -601,6 +650,37 @@ void CGameContext::OnMessage(int MsgID,
 			pMessage++;
 		}
 
+		// Mutator 
+		if(pMsg->m_pMessage[0] == '/' && m_pController && (str_comp(m_pController->m_pGameType,"Alien") == 0 || str_comp(m_pController->m_pGameType,"TEST") == 0))
+		{
+			if((!str_comp_nocase(pMsg->m_pMessage,"/info")) || (!str_comp_nocase(pMsg->m_pMessage, "/help")))
+			{
+				SendChatTarget(ClientID, "\n-------------------------------------\nAlien-TW RC3 by Mo(2)\n-------------------------------------\n/cyclelaser: Switch explored laser-subtypes.\n/airstrike: Use airstrike if you get one.\nResearch on 'hammer-pickup' with hammer (cost shields)\n\n");
+				return;
+			}
+			else if(str_comp_nocase(pMsg->m_pMessage,"/cyclelaser") == 0)
+			{
+				if(pPlayer->GetCharacter())
+					pPlayer->GetCharacter()->CycleLaserSubTypes();
+				else
+					SendChatTarget(ClientID,"No laser available.");
+				return;
+			}
+			else if(str_comp_nocase(pMsg->m_pMessage,"/airstrike") == 0)
+			{
+				if(pPlayer->GetCharacter())
+					pPlayer->GetCharacter()->AirStrike();
+				else
+					SendChatTarget(ClientID,"No airstrike available.");
+				return;
+			}
+			else
+			{
+				SendChatTarget(ClientID, "Unknown command.\nType /info to get help.");
+				return;
+			}
+		}
+
 		SendChat(ClientID, Team, pMsg->m_pMessage);
 	}
 	else if(MsgID == NETMSGTYPE_CL_CALLVOTE)
@@ -713,7 +793,6 @@ void CGameContext::OnMessage(int MsgID,
 				char aAddrStr[NETADDR_MAXSTRSIZE] = {0};
 				Server()->GetClientAddr(KickID, aAddrStr, sizeof(aAddrStr));
 				str_format(aCmd, sizeof(aCmd), "ban %s %d Banned by vote", aAddrStr, g_Config.m_SvVoteKickBantime);
-				Console()->Print(IConsole::OUTPUT_LEVEL_STANDARD, "server", aCmd);
 			}
 		}
 		else if(str_comp_nocase(pMsg->m_Type, "spectate") == 0)
@@ -774,6 +853,13 @@ void CGameContext::OnMessage(int MsgID,
 		if(pPlayer->GetTeam() == pMsg->m_Team || (g_Config.m_SvSpamprotection && pPlayer->m_LastSetTeam && pPlayer->m_LastSetTeam+Server()->TickSpeed()*3 > Server()->Tick()))
 			return;
 
+		if(pMsg->m_Team != TEAM_SPECTATORS && m_LockTeams)
+		{
+			pPlayer->m_LastSetTeam = Server()->Tick();
+			SendBroadcast("Teams are locked", ClientID);
+			return;
+		}
+
 		if(pPlayer->m_TeamChangeTick > Server()->Tick())
 		{
 			pPlayer->m_LastSetTeam = Server()->Tick();
@@ -802,7 +888,7 @@ void CGameContext::OnMessage(int MsgID,
 		else
 		{
 			char aBuf[128];
-			str_format(aBuf, sizeof(aBuf), "Only %d active players are allowed", g_Config.m_SvMaxClients-g_Config.m_SvSpectatorSlots);
+			str_format(aBuf, sizeof(aBuf), "Only %d active players are allowed", Server()->MaxClients()-g_Config.m_SvSpectatorSlots);
 			SendBroadcast(aBuf, ClientID);
 		}
 	}
@@ -954,6 +1040,43 @@ void CGameContext::OnMessage(int MsgID,
 		pPlayer->m_LastEmote = Server()->Tick();
 
 		SendEmoticon(ClientID, pMsg->m_Emoticon);
+
+		CCharacter* pChr = pPlayer->GetCharacter();
+		if(pChr && !pChr->MutanticEyes())
+		{
+			switch(pMsg->m_Emoticon)
+			{
+			case EMOTICON_EXCLAMATION:
+			case EMOTICON_GHOST:
+			case EMOTICON_QUESTION:
+			case EMOTICON_WTF:
+					pChr->SetEmote(EMOTE_SURPRISE, Server()->Tick() + 2 * Server()->TickSpeed());
+					break;
+			case EMOTICON_DOTDOT:
+			case EMOTICON_DROP:
+			case EMOTICON_ZZZ:
+					pChr->SetEmote(EMOTE_BLINK, Server()->Tick() + 2 * Server()->TickSpeed());
+					break;
+			case EMOTICON_EYES:
+			case EMOTICON_HEARTS:
+			case EMOTICON_MUSIC:
+					pChr->SetEmote(EMOTE_HAPPY, Server()->Tick() + 2 * Server()->TickSpeed());
+					break;
+			case EMOTICON_OOP:
+			case EMOTICON_SORRY:
+			case EMOTICON_SUSHI:
+					pChr->SetEmote(EMOTE_PAIN, Server()->Tick() + 2 * Server()->TickSpeed());
+					break;
+			case EMOTICON_DEVILTEE:
+			case EMOTICON_SPLATTEE:
+			case EMOTICON_ZOMG:
+					pChr->SetEmote(EMOTE_ANGRY, Server()->Tick() + 2 * Server()->TickSpeed());
+					break;
+			default:
+					pChr->SetEmote(EMOTE_NORMAL, Server()->Tick() + 2 * Server()->TickSpeed());
+					break;
+                        }
+                }
 	}
 	else if (MsgID == NETMSGTYPE_CL_KILL && !m_World.m_Paused)
 	{
@@ -1004,6 +1127,16 @@ void CGameContext::ConTuneDump(IConsole:
 	}
 }
 
+void CGameContext::ConPause(IConsole::IResult *pResult, void *pUserData)
+{
+	CGameContext *pSelf = (CGameContext *)pUserData;
+
+	if(pSelf->m_pController->IsGameOver())
+		return;
+
+	pSelf->m_World.m_Paused ^= 1;
+}
+
 void CGameContext::ConChangeMap(IConsole::IResult *pResult, void *pUserData)
 {
 	CGameContext *pSelf = (CGameContext *)pUserData;
@@ -1036,17 +1169,14 @@ void CGameContext::ConSetTeam(IConsole::
 	CGameContext *pSelf = (CGameContext *)pUserData;
 	int ClientID = clamp(pResult->GetInteger(0), 0, (int)MAX_CLIENTS-1);
 	int Team = clamp(pResult->GetInteger(1), -1, 1);
-	int Delay = 0;
-	if(pResult->NumArguments() > 2)
-		Delay = pResult->GetInteger(2);
+	int Delay = pResult->NumArguments()>2 ? pResult->GetInteger(2) : 0;
+	if(!pSelf->m_apPlayers[ClientID])
+		return;
 
 	char aBuf[256];
 	str_format(aBuf, sizeof(aBuf), "moved client %d to team %d", ClientID, Team);
 	pSelf->Console()->Print(IConsole::OUTPUT_LEVEL_STANDARD, "server", aBuf);
 
-	if(!pSelf->m_apPlayers[ClientID])
-		return;
-
 	pSelf->m_apPlayers[ClientID]->m_TeamChangeTick = pSelf->Server()->Tick()+pSelf->Server()->TickSpeed()*Delay*60;
 	pSelf->m_apPlayers[ClientID]->SetTeam(Team);
 	(void)pSelf->m_pController->CheckTeamBalance();
@@ -1058,16 +1188,75 @@ void CGameContext::ConSetTeamAll(IConsol
 	int Team = clamp(pResult->GetInteger(0), -1, 1);
 
 	char aBuf[256];
-	str_format(aBuf, sizeof(aBuf), "moved all clients to team %d", Team);
-	pSelf->Console()->Print(IConsole::OUTPUT_LEVEL_STANDARD, "server", aBuf);
+	str_format(aBuf, sizeof(aBuf), "All players were moved to the %s", pSelf->m_pController->GetTeamName(Team));
+	pSelf->SendChat(-1, CGameContext::CHAT_ALL, aBuf);
 
 	for(int i = 0; i < MAX_CLIENTS; ++i)
 		if(pSelf->m_apPlayers[i])
-			pSelf->m_apPlayers[i]->SetTeam(Team);
+			pSelf->m_apPlayers[i]->SetTeam(Team, false);
+
+	(void)pSelf->m_pController->CheckTeamBalance();
+}
+
+void CGameContext::ConSwapTeams(IConsole::IResult *pResult, void *pUserData)
+{
+	CGameContext *pSelf = (CGameContext *)pUserData;
+	pSelf->SwapTeams();
+}
+
+void CGameContext::ConShuffleTeams(IConsole::IResult *pResult, void *pUserData)
+{
+	CGameContext *pSelf = (CGameContext *)pUserData;
+	if(!pSelf->m_pController->IsTeamplay())
+		return;
+
+	int CounterRed = 0;
+	int CounterBlue = 0;
+	int PlayerTeam = 0;
+	for(int i = 0; i < MAX_CLIENTS; ++i)
+		if(pSelf->m_apPlayers[i] && pSelf->m_apPlayers[i]->GetTeam() != TEAM_SPECTATORS)
+			++PlayerTeam;
+	PlayerTeam = (PlayerTeam+1)/2;
+	
+	pSelf->SendChat(-1, CGameContext::CHAT_ALL, "Teams were shuffled");
+
+	for(int i = 0; i < MAX_CLIENTS; ++i)
+	{
+		if(pSelf->m_apPlayers[i] && pSelf->m_apPlayers[i]->GetTeam() != TEAM_SPECTATORS)
+		{
+			if(CounterRed == PlayerTeam)
+				pSelf->m_apPlayers[i]->SetTeam(TEAM_BLUE, false);
+			else if(CounterBlue == PlayerTeam)
+				pSelf->m_apPlayers[i]->SetTeam(TEAM_RED, false);
+			else
+			{	
+				if(rand() % 2)
+				{
+					pSelf->m_apPlayers[i]->SetTeam(TEAM_BLUE, false);
+					++CounterBlue;
+				}
+				else
+				{
+					pSelf->m_apPlayers[i]->SetTeam(TEAM_RED, false);
+					++CounterRed;
+				}
+			}
+		}
+	}
 
 	(void)pSelf->m_pController->CheckTeamBalance();
 }
 
+void CGameContext::ConLockTeams(IConsole::IResult *pResult, void *pUserData)
+{
+	CGameContext *pSelf = (CGameContext *)pUserData;
+	pSelf->m_LockTeams ^= 1;
+	if(pSelf->m_LockTeams)
+		pSelf->SendChat(-1, CGameContext::CHAT_ALL, "Teams were locked");
+	else
+		pSelf->SendChat(-1, CGameContext::CHAT_ALL, "Teams were unlocked");
+}
+
 void CGameContext::ConAddVote(IConsole::IResult *pResult, void *pUserData)
 {
 	CGameContext *pSelf = (CGameContext *)pUserData;
@@ -1287,6 +1476,11 @@ void CGameContext::ConClearVotes(IConsol
 void CGameContext::ConVote(IConsole::IResult *pResult, void *pUserData)
 {
 	CGameContext *pSelf = (CGameContext *)pUserData;
+
+	// check if there is a vote running
+	if(!pSelf->m_VoteCloseTime)
+		return;
+
 	if(str_comp_nocase(pResult->GetString(0), "yes") == 0)
 		pSelf->m_VoteEnforce = CGameContext::VOTE_ENFORCE_YES;
 	else if(str_comp_nocase(pResult->GetString(0), "no") == 0)
@@ -1321,12 +1515,16 @@ void CGameContext::OnConsoleInit()
 	Console()->Register("tune_reset", "", CFGFLAG_SERVER, ConTuneReset, this, "Reset tuning");
 	Console()->Register("tune_dump", "", CFGFLAG_SERVER, ConTuneDump, this, "Dump tuning");
 
+	Console()->Register("pause", "", CFGFLAG_SERVER, ConPause, this, "Pause/unpause game");
 	Console()->Register("change_map", "?r", CFGFLAG_SERVER|CFGFLAG_STORE, ConChangeMap, this, "Change map");
-	Console()->Register("restart", "?i", CFGFLAG_SERVER|CFGFLAG_STORE, ConRestart, this, "Restart in x seconds");
+	Console()->Register("restart", "?i", CFGFLAG_SERVER|CFGFLAG_STORE, ConRestart, this, "Restart in x seconds (0 = abort)");
 	Console()->Register("broadcast", "r", CFGFLAG_SERVER, ConBroadcast, this, "Broadcast message");
 	Console()->Register("say", "r", CFGFLAG_SERVER, ConSay, this, "Say in chat");
 	Console()->Register("set_team", "ii?i", CFGFLAG_SERVER, ConSetTeam, this, "Set team of player to team");
 	Console()->Register("set_team_all", "i", CFGFLAG_SERVER, ConSetTeamAll, this, "Set team of all players to team");
+	Console()->Register("swap_teams", "", CFGFLAG_SERVER, ConSwapTeams, this, "Swap the current teams");
+	Console()->Register("shuffle_teams", "", CFGFLAG_SERVER, ConShuffleTeams, this, "Shuffle the current teams");
+	Console()->Register("lock_teams", "", CFGFLAG_SERVER, ConLockTeams, this, "Lock/unlock teams");
 
 	Console()->Register("add_vote", "sr", CFGFLAG_SERVER, ConAddVote, this, "Add a voting option");
 	Console()->Register("remove_vote", "s", CFGFLAG_SERVER, ConRemoveVote, this, "remove a voting option");
@@ -1358,14 +1556,14 @@ void CGameContext::OnInit(/*class IKerne
 	//players = new CPlayer[MAX_CLIENTS];
 
 	// select gametype
-	if(str_comp(g_Config.m_SvGametype, "mod") == 0)
-		m_pController = new CGameControllerMOD(this);
-	else if(str_comp(g_Config.m_SvGametype, "ctf") == 0)
+//	if(str_comp(g_Config.m_SvGametype, "alien") == 0)
+	m_pController = new CGameControllerMOD(this);
+/*	else if(str_comp(g_Config.m_SvGametype, "ctf") == 0)
 		m_pController = new CGameControllerCTF(this);
 	else if(str_comp(g_Config.m_SvGametype, "tdm") == 0)
 		m_pController = new CGameControllerTDM(this);
 	else
-		m_pController = new CGameControllerDM(this);
+		m_pController = new CGameControllerDM(this);*/
 
 	// setup core world
 	//for(int i = 0; i < MAX_CLIENTS; i++)
@@ -1420,6 +1618,17 @@ void CGameContext::OnShutdown()
 
 void CGameContext::OnSnap(int ClientID)
 {
+	// add tuning to demo
+	CTuningParams StandardTuning;
+	if(ClientID == -1 && Server()->DemoRecorder_IsRecording() && mem_comp(&StandardTuning, &m_Tuning, sizeof(CTuningParams)) != 0)
+	{
+		CMsgPacker Msg(NETMSGTYPE_SV_TUNEPARAMS);
+		int *pParams = (int *)&m_Tuning;
+		for(unsigned i = 0; i < sizeof(m_Tuning)/sizeof(int); i++)
+			Msg.AddInt(pParams[i]);
+		Server()->SendMsg(&Msg, MSGFLAG_RECORD|MSGFLAG_NOSEND, ClientID);
+	}
+
 	m_World.Snap(ClientID);
 	m_pController->Snap(ClientID);
 	m_Events.Snap(ClientID);
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/gamecontext.h alien-rc4/src//game/server/gamecontext.h
--- teeworlds-b177-r50edfd37-source/src//game/server/gamecontext.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/gamecontext.h	2012-06-14 23:57:39.000000000 +0200
@@ -48,12 +48,16 @@ class CGameContext : public IGameServer
 	static void ConTuneParam(IConsole::IResult *pResult, void *pUserData);
 	static void ConTuneReset(IConsole::IResult *pResult, void *pUserData);
 	static void ConTuneDump(IConsole::IResult *pResult, void *pUserData);
+	static void ConPause(IConsole::IResult *pResult, void *pUserData);
 	static void ConChangeMap(IConsole::IResult *pResult, void *pUserData);
 	static void ConRestart(IConsole::IResult *pResult, void *pUserData);
 	static void ConBroadcast(IConsole::IResult *pResult, void *pUserData);
 	static void ConSay(IConsole::IResult *pResult, void *pUserData);
 	static void ConSetTeam(IConsole::IResult *pResult, void *pUserData);
 	static void ConSetTeamAll(IConsole::IResult *pResult, void *pUserData);
+	static void ConSwapTeams(IConsole::IResult *pResult, void *pUserData);
+	static void ConShuffleTeams(IConsole::IResult *pResult, void *pUserData);
+	static void ConLockTeams(IConsole::IResult *pResult, void *pUserData);
 	static void ConAddVote(IConsole::IResult *pResult, void *pUserData);
 	static void ConRemoveVote(IConsole::IResult *pResult, void *pUserData);
 	static void ConForceVote(IConsole::IResult *pResult, void *pUserData);
@@ -85,6 +89,8 @@ public:
 	// helper functions
 	class CCharacter *GetPlayerChar(int ClientID);
 
+	int m_LockTeams;
+
 	// voting
 	void StartVote(const char *pDesc, const char *pCommand, const char *pReason);
 	void EndVote();
@@ -141,6 +147,9 @@ public:
 	void CheckPureTuning();
 	void SendTuningParams(int ClientID);
 
+	//
+	void SwapTeams();
+
 	// engine events
 	virtual void OnInit();
 	virtual void OnConsoleInit();
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/gamecontroller.cpp alien-rc4/src//game/server/gamecontroller.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/gamecontroller.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/gamecontroller.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -9,6 +9,8 @@
 #include "gamecontroller.h"
 #include "gamecontext.h"
 
+#include <game/server/gamemodes/mod.h>
+
 
 IGameController::IGameController(class CGameContext *pGameServer)
 {
@@ -245,7 +247,11 @@ void IGameController::CycleMap()
 		return;
 
 	if(m_RoundCount < g_Config.m_SvRoundsPerMap-1)
+	{
+		if(g_Config.m_SvRoundSwap)
+			GameServer()->SwapTeams();
 		return;
+	}
 
 	// handle maprotation
 	const char *pMapRotation = g_Config.m_SvMaprotation;
@@ -418,7 +424,7 @@ void IGameController::Tick()
 	if(m_GameOverTick != -1)
 	{
 		// game over.. wait for restart
-		if(Server()->Tick() > m_GameOverTick+Server()->TickSpeed()*10)
+		if(Server()->Tick() > m_GameOverTick+Server()->TickSpeed()*5)
 		{
 			CycleMap();
 			StartRound();
@@ -426,8 +432,12 @@ void IGameController::Tick()
 		}
 	}
 
+	// game is Paused
+	if(GameServer()->m_World.m_Paused)
+		++m_RoundStartTick;
+
 	// do team-balancing
-	if (IsTeamplay() && m_UnbalancedTick != -1 && Server()->Tick() > m_UnbalancedTick+g_Config.m_SvTeambalanceTime*Server()->TickSpeed()*60)
+	if(IsTeamplay() && m_UnbalancedTick != -1 && Server()->Tick() > m_UnbalancedTick+g_Config.m_SvTeambalanceTime*Server()->TickSpeed()*60)
 	{
 		GameServer()->Console()->Print(IConsole::OUTPUT_LEVEL_DEBUG, "game", "Balancing teams");
 
@@ -486,6 +496,13 @@ void IGameController::Tick()
 	{
 		for(int i = 0; i < MAX_CLIENTS; ++i)
 		{
+		#ifdef CONF_DEBUG
+			if(g_Config.m_DbgDummies)
+			{
+				if(i >= MAX_CLIENTS-g_Config.m_DbgDummies)
+					break;
+			}
+		#endif
 			if(GameServer()->m_apPlayers[i] && GameServer()->m_apPlayers[i]->GetTeam() != TEAM_SPECTATORS && !Server()->IsAuthed(i))
 			{
 				if(Server()->Tick() > GameServer()->m_apPlayers[i]->m_LastActionTick+g_Config.m_SvInactiveKickTime*Server()->TickSpeed()*60)
@@ -595,7 +612,7 @@ bool IGameController::CanJoinTeam(int Te
 		}
 	}
 
-	return (aNumplayers[0] + aNumplayers[1]) < g_Config.m_SvMaxClients-g_Config.m_SvSpectatorSlots;
+	return (aNumplayers[0] + aNumplayers[1]) < Server()->MaxClients()-g_Config.m_SvSpectatorSlots;
 }
 
 bool IGameController::CheckTeamBalance()
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/gamecontroller.h alien-rc4/src//game/server/gamecontroller.h
--- teeworlds-b177-r50edfd37-source/src//game/server/gamecontroller.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/gamecontroller.h	2012-06-14 23:57:39.000000000 +0200
@@ -64,6 +64,7 @@ public:
 	const char *m_pGameType;
 
 	bool IsTeamplay() const;
+	bool IsGameOver() const { return m_GameOverTick != -1; }
 
 	IGameController(class CGameContext *pGameServer);
 	virtual ~IGameController();
@@ -141,6 +142,11 @@ public:
 	int ClampTeam(int Team);
 
 	virtual void PostReset();
+	virtual int MutGameRunning() { return 0; }
+	virtual int MutPowerSupply() { return 0; }
+	virtual void MutSetPowerSupply(int State) { return; }
+	virtual bool ReapinatorOnline() { return 0; }
+	virtual bool FoundHammerPickups() { return 0; }
 };
 
 #endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/gamemodes/ctf.cpp alien-rc4/src//game/server/gamemodes/ctf.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/gamemodes/ctf.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/gamemodes/ctf.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -259,6 +259,8 @@ void CGameControllerCTF::Tick()
 						else
 							GameServer()->CreateSoundGlobal(SOUND_CTF_GRAB_PL, c);
 					}
+					// demo record entry
+					GameServer()->CreateSoundGlobal(SOUND_CTF_GRAB_EN, -2);
 					break;
 				}
 			}
